unit Unit1;
{
 versie 1.3   nov. 2003
} 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Buttons, StdCtrls, ExtCtrls, ComCtrls;

type
  Tmainform = class(TForm)
    CoeffGrid: TStringGrid;
    ConstGrid: TStringGrid;
    StaticText1: TStaticText;
    StaticText4: TStaticText;
    savebtn: TBitBtn;
    reloadbtn: TBitBtn;
    resetbtn: TBitBtn;
    Comments: TStaticText;
    HorArrow: TImage;
    VertArrow: TImage;
    RedArrow: TImage;
    GoBtn: TBitBtn;
    coltext: TStaticText;
    colupBtn: TBitBtn;
    coldownBtn: TBitBtn;
    BitBtn1: TBitBtn;
    modebtn: TBitBtn;
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure resetbtnClick(Sender: TObject);
    procedure savebtnClick(Sender: TObject);
    procedure reloadbtnClick(Sender: TObject);
    procedure colupBtnClick(Sender: TObject);
    procedure GoBtnClick(Sender: TObject);
    procedure CoeffGridSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure ConstGridSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure CoeffGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ConstGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn1Click(Sender: TObject);
    procedure modebtnClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mainform: Tmainform;

implementation

uses Unit2;

{$R *.DFM}

// variabelen

var A : array[1..9,1..10] of double;   // 9 rows , 9 columns + const column 10
    AH : array[1..10,1..9] of string;  // memory
      nhist : byte;                 // memory
          n : byte;                // aantal rijen, kolommen
   col, row : byte;                // run time counters
      cbias : smallint;            // pos. of first gridcolumn {7-nc}
       busy : boolean;             // if solving equations
      pause : boolean;             // to show intermidiate results
       step : boolean;             //step mode

procedure SetStep(f : boolean);
var i : byte;
begin
 step := f;
 with mainform.paintbox1 do
 begin
  canvas.Brush.style := bsSolid;
  canvas.brush.color := mainform.color;
  canvas.fillrect(clientrect);
  canvas.font.color := clyellow;
  canvas.pen.width := 2;
  canvas.brush.style := bsClear;
  canvas.font.Size := 12;
  if step then
  begin
   canvas.pen.color := clred;
   for i := 0 to 3 do
   begin
    canvas.moveto(i*17,68-i*17);
    canvas.lineto((i+1)*17,68-i*17);
    canvas.lineto((i+1)*17,68-(i+1)*17);
   end;
   canvas.textout(20,20,'step');
  end
  else
  begin
   canvas.pen.color := $008000;
   canvas.moveto(0,68);
   canvas.lineto(68,0);
   canvas.textout(10,20,'direct');
  end;
 end;
end;

procedure showcoeff;         //A[..] to grids during stepmode
var i,j : byte;
begin
 for i := 1 to n do
 begin
  mainform.constGrid.Cells[0,i]:= FloatToStr(A[i,n+1]);
  for j := 1 to n do
   mainform.CoeffGrid.Cells[cbias + j,i] := FloatToStr(a[i,j]);
 end;
end;

procedure PosHorArrow(hh : word);            // hh : col 0 .....
begin
 with mainform do
 begin
  HorArrow.Top := (hh-1) * 26 + 120;
  HorArrow.Visible := true;
 end;
end;

procedure PosVertArrow(hh : byte);  // hh : col 1..9  10
begin
 with mainform do
 begin
  if hh = n+1 then  VertArrow.Left := 650
  else VertArrow.Left := (cbias+hh) * 67 + 48;
  VertArrow.visible := true;
 end;
end;

procedure PosredArrow(hh : byte);            // hh : row 0 ....
begin
 with mainform do
 begin
  RedArrow.Top := (hh-1) * 26 + 120;
  redArrow.visible := true;
 end;
end;

procedure Arrows(vv,gg,rr : byte);  //relative to coeff. array
begin
 with mainform do
 begin
  if vv = 0 then VertArrow.visible := false
  else PosVertArrow(vv);
  if gg = 0 then HorArrow.visible := false
  else PosHorArrow(gg);
  if rr = 0 then RedArrow.visible := false
  else PosRedArrow(rr);
 end;
end;

procedure InitGrids;  //set grid acc. to cols,rows , empty strings
var i,j : byte;
begin
 with MainForm do
 begin
  CoeffGrid.row := 1;
  CoeffGrid.col := 9-n;
  ConstGrid.Row := 1;
  cbias := 8 - n;
  for i := 0 to 8 do CoeffGrid.Cells[i,0] := '';
  for j := 1 to 9 do
  begin
   constGrid.Cells[0,j] := '';
   for i := 0 to 8 do
    CoeffGrid.Cells[i,j] := '';
  end;
  for i := 1 to n do
   Coeffgrid.Cells[i + cbias,0] := Char(Ord('a') + i-1);
  for j := 1 to n do
  begin
   ConstGrid.Cells[0,j] := '0';
   for i := 1 to n do
    CoeffGrid.Cells[i + cbias,j] := '0';
  end;
  coeffgrid.col := cbias + 1;
 end;
 Arrows(0,0,0);
 setstep(false);
 mainform.comments.caption :=
      'Select number of columns, rows. Supply numbers.';
end;

procedure showdimensions;
begin
 with mainform do
 begin
  coltext.caption := IntToStr(n);
  cbias := 8 - n;
 end;
end;

procedure Tmainform.FormCreate(Sender: TObject);
var i : byte;
begin
 n := 2;
 busy := false;
 pause := false;
 cbias := 8 - n;
 showdimensions;
 initgrids;
 SaveBtnClick(self);
end;

procedure Tmainform.ResetbtnClick(Sender: TObject);
var i,j : byte;
begin
 InitGrids;
end;

function s2flfail(ss : string) : boolean;
var i, np : byte;
begin
 result := true;   // indicate failure
 if length(ss) = 0 then exit;
 np := 0;   //aantal punten ....
 for i := 1 to length(ss) do
  case ss[i] of
              '0'..'9' :;
                   ',' : np := np + 1;
               '+','-' : if i > 1 then np := 10;
   else  np := 10
  end;
 if np > 1 then exit; //teveel ....of andere fouten
 result := false;  // indicate ok
end;

Function CoeffCheck : boolean ; //true if error
var s : string;
begin
 result := false;
 for col := 1  to n do
  for row := 1 to n do
  begin
   s := mainform.CoeffGrid.Cells[col+cbias,row]; //string ophalen
   if s2flfail(s) then
   begin
    result := true;
    Arrows(col,0,row);
    exit;
   end
   else A[row,col] := StrToFloat(s);
  end;
  col := 10 - cbias;
 for row := 1 to n do
 begin
  s := mainform.ConstGrid.Cells[0,row];
  if s2flfail(s) then
  begin
   result := true;
   Arrows(n+1,0,row);
   exit;
  end
  else  A[row,n+1] := StrToFloat(s);
 end;
end;

procedure Tmainform.savebtnClick(Sender: TObject);
var i,j : byte;
begin
  for i := 1 to 9 do
  begin
   AH[10,i] := Constgrid.Cells[0,i];
   for j := 1 to 9 do
    AH[i,j] := Coeffgrid.cells[j-1,i];
  end;
  nhist := n;
end;

procedure Tmainform.reloadbtnClick(Sender: TObject);
var i,j : byte;
begin
  coeffgrid.row := 1;
  coeffgrid.col := 8;
  constgrid.row := 1;
  for i := 1 to 9 do
  begin
    Constgrid.Cells[0,i] := AH[10,i];
   for j := 1 to 9 do
     Coeffgrid.Cells[j-1,i] := AH[i,j];
  end;
   n := nhist;
   cbias := 8 - n;
   for i := 1 to 9 do Coeffgrid.Cells[i,0] := '';
   for i := 1 to n do
   Coeffgrid.Cells[i + cbias,0] := Char(Ord('a') + i-1);
   coeffgrid.col := cbias + 1;
   ShowDimensions;
end;

procedure Tmainform.colupBtnClick(Sender: TObject);
var i : smallint;
begin
  if busy then exit;
  if sender = colupbtn then i := 1
   else i := -1;
  if ((n + i) >= 2) and ((n + i) <= 9) then
     n := n + i;
  coltext.caption := IntToStr(n);
  InitGrids;
end;

procedure Wait;
begin
 pause := true;
 while pause do Application.ProcessMessages;
end;

procedure Msg1A(r1,r2,rv : byte);
begin
 mainform.Comments.caption := 'trade rows '
                              +IntToStr(r1)+' en '+IntToStr(r2);
 Arrows(rv,r1,r2);
 showcoeff;
 wait;
end;

procedure Msg2A(a,b : byte; c: double);
begin
 Arrows(b,a,0);
 mainform.comments.caption := 'multiply row '+IntToStr(a)
                              +' with '+FloatToStr(c);
 showcoeff;
 wait;
end;

procedure Msg2B(a,b,c : byte);
begin
 mainform.comments.caption := 'subtract row '+IntToStr(c)+
                              ' from row '+IntToStr(b);
 showcoeff;
 Arrows(c,a,b);
 wait;
end;

procedure Msg3A(a,b : byte; f : double);
begin
 mainform.comments.caption := 'divide row '+IntToStr(a)
                              +' by '+FloatTostr(f);
 Arrows(b,0,a);
 showcoeff;
 wait;
end;

procedure SwapRows(r1,r2,rv : byte);
var i : byte;
    h : double;
begin
 if step then Msg1A(r1,r2,rv);     // going to swap rows
 for i := 1 to n+1 do
 begin
  h := A[r1,i]; A[r1,i] := A[r2,i]; A[r2,i] := h;
 end;
end;

procedure Solve;
var i, j, k , diag : byte;
          f : double;
begin
 for diag := 1 to n-1 do           //zoek pivot kolom 'diag'
 begin
  k := diag;                      // wijst grootste aan
  for i := diag+1 to n do        // i is rowteller
   if Abs(A[k,diag]) < abs(A[i,diag]) then k := i;
  if k <> diag then SwapRows(diag,k,diag);

  for i := diag to n do         // maak kolom onder 'diag' = 1
   if (A[i,diag] <> 0) and (A[i,diag] <> 1) then
   begin
    f := A[i,diag];
    if step then Msg3A(i,diag,f);
    for k := 1 to n+1 do A[i,k] := A[i,k] / f;  // maak = 1
   end;

  for i := diag+1 to n do               //kolom onder diag = 0 maken
   if A[i,diag] <> 0 then
   begin
    if step then Msg2B(diag,i,diag);     // subtract rows
    for k := diag+1 to n+1 do
     begin
      A[i,k] := A[i,k] - A[diag,k];
      if abs(A[i,k]) < 1e-10 then A[i,k] := 0; //fix grote getallen=====
     end;
    A[i,diag] := 0;
   end;
 end;

// column elimination up

 for diag := n downto 1 do
 if A[diag,diag] <> 0 then
 begin
  for i := diag downto 1 do          //kolom onder diag = 1 maken
  begin
   f := A[i,diag];
   if (f <> 0) and (f <> 1) then
   begin
    if step then Msg3A(i,diag,f);    //delen
    for j := 1 to n+1 do A[i,j] := A[i,j] / f;
   end;
  end;
  for i := diag-1 downto 1 do
  begin
   if (A[i,diag] <> 0) then             //trek af
   begin
    if step then Msg2B(diag,i,diag);
    for j := diag to n+1 do
     begin
      A[i,j] := A[i,j] - A[diag,j];
      if abs(A[i,j]) < 1e-10 then A[i,j] := 0; //fix grote getallen=====
     end;
   end;
  end;
 end;

 // test voor oplossing

 k := 0;  //error flag
 for i := 1 to n do
  for j := 1 to n do
  begin
   if (i = j) and (A[i,i] = 0) then k := k + 1;
   if (i <> j) and (A[j,i] <> 0 ) then k := k + 1;
  end;
 if k = 0 then MainForm.comments.caption := 'the system is solved'
 else MainForm.comments.caption := 'the system has no solution';
 Arrows(0,0,0);
end;

procedure SetBusy;
begin
 mainform.coeffgrid.options := mainform.coeffgrid.options - [goediting];
 mainform.constgrid.options := mainform.constgrid.options - [goediting];
 busy := true;
 with mainform do
 begin
  SaveBtn.enabled := false;
  ReloadBtn.Enabled := false;
  ResetBtn.Enabled := false;
 end;
end;

procedure clearBusy;
begin
 busy := false;
 mainform.coeffgrid.options := mainform.coeffgrid.options + [goediting];
 mainform.constgrid.options := mainform.constgrid.options + [goediting];
 with mainform do
 begin
  SaveBtn.enabled := true;
  ReloadBtn.Enabled := true;
  ResetBtn.Enabled := true;
 end;
end;

procedure Tmainform.GoBtnClick(Sender: TObject); //oplossen vergelijkingen
begin
 if busy then
 begin
  pause := false;
  exit;
 end;
 if coeffcheck then     //kopieert de strings naar het array 1..nc, nc+1
 begin
  comments.caption := 'coefficient error';
  exit;
 end;
 SetBusy;
 Solve;
 showcoeff;
 ClearBusy;
end;

procedure Tmainform.CoeffGridSelectCell(Sender: TObject; Col, Row: Integer;
                                         var CanSelect: Boolean);
var   s : string ;
begin
   CanSelect := (col > cbias) and (row <= n);
   if canselect and (not busy) then
     comments.caption := CoeffGrid.cells[col,row]; 
end;

procedure Tmainform.ConstGridSelectCell(Sender: TObject; Col, Row: Integer;
                                        var CanSelect: Boolean);
var s : string;
begin
  CanSelect := row <= n;
    if canselect and (not busy) then
     comments.caption := ConstGrid.cells[col,row] ;
end;

procedure Tmainform.CoeffGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 13 then
  begin
   if CoeffGrid.col < 8 then CoeffGrid.col := CoeffGrid.Col + 1
   else
   begin
    Constgrid.row := CoeffGrid.row;
    ConstGrid.SetFocus;
   end;
   key := 0;
  end;
end;

procedure Tmainform.ConstGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 13 then
  begin
   if ConstGrid.Row < n then
    CoeffGrid.Row := ConstGrid.Row + 1
   else
    CoeffGrid.Row := 1;
    CoeffGrid.col := cbias+1;
    CoeffGrid.setFocus;
    key := 0;
  end;
end;

procedure Tmainform.BitBtn1Click(Sender: TObject);
begin
  mainform.enabled := false;
  aboutform.enabled := true;
  aboutform.show;
end;

procedure Tmainform.modebtnClick(Sender: TObject);
begin
  setstep(not step);
end;

procedure Tmainform.PaintBox1Paint(Sender: TObject);
begin
  setstep(step);
end;

procedure Tmainform.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  step := false;
  pause := false;  // en het programma loopt naar z'n einde
end;

end.
